url: semup.html
date: 2023-06-04
author: Rahul Jha
title: Semester Update
tags: update, math, rant
summary: 2 down, 2 to go. Also, I am bored.

## Prologue
The semester started with a bang, with Inter-IIT and two fests in quick succession. I had the time of my life, made new friends, and missed lectures because of my hubris. Then like a caffeine induced high, it crashed. Lately, life has fallen into a rhythm. Do not study during the semester, then start praying to God before endsems, somehow still screw up the exams. Visit a hospital because why not, test health guidelines by OD-ing on sting. Get lacklustre grades, to no one's apparent surprise. After an hour of crying after the results, eat a brick of ice-cream and start manifesting a perfect 10 in the next semester. Shamelessly, post a _semester-dump_ comprising mainly of stolen and uncredited photos to get 80 likes. Switch on do not disturb, only to turn it off 10 seconds later to see if she messaged. Turn it back on. Solve useless problems on a useless website in order to prepare for a meaningless job. Don't talk to anyone, but not by choice. Their lives are order of magnitudes more interesting and they have much better people to talk to. Finally get a good news, a foreign admit. But reject it because it clashes with the next semester, and you were stupid enough to apply without looking at the timelines. This post, however, is not about the lull in my life. It is _because_ of the lull in my life.

## Stalking Update: Instagram
The OGs remember [Udta Ghoda](https://juggernautjha.gitlab.io/c17e/posts/udta_ghoda.html), an instagram scraper I wrote when I had nothing better to do. Turns out, there is a simpler way of finding out your crush' boyfriend using vanilla API requests. The other day, after screwing up the Algebra exam, I was going all Mr. Robot over Instagram's network calls and found a benign-ass endpoint. I was 100% sure that it would not work from the command line because I had undue faith in the engineers at Meta (however given that I cannot reply on my burner account, I guess they have proven their incompetence beyond reasonable doubt). To my great surprise, it worked. The data was structured, and required minimal processing before it could be used for large scale 1984-esque shit. I ran some pretty standard statistics to find out who my closest friend was, where I defined closeness naively as the number of mutual friends, upto two levels. As an illustration, suppose I know Ramesh, Suresh, and Jayesh. Friend A knows Ramesh and Jayesh. Friend B knows Ramesh, Jayesh and Rakesh, and Rakesh knows Suresh. Then, according to my stupid-ass metric friend B is a closer friend than friend A. Like most modern scientists, I kept the depth as a hyperparameter, varying it from 2 to 10 so that the results confirmed my biases. I will link the notebook if you want to replicate this with your friends. I would recommend not doing this and instead just asking them if they consider you a friend. That way, you are almost guaranteed a positive response. I do not remember saying no to anyone. A creepier consequence of Meta engineers not paying attention to their APIs is that I can download basically every photo people I follow have posted without putting in a lot of work. I did not do that because I haven't had good experiences with unauthorized media downloads. All the code is [here](https://github.com/juggernautjha/udtaghoda). It is very well documented, so do not even think about trolling me for the lack of comments. 
Also, turns out Instagram rate limits network calls. This should have been obvious.

## Stalking Update: Pingala
Pingala has to be the promised land. The number of unsanitized endpoints in Pingala dwarves that in Nankari. By a considerable margin. I spent the better part of April scrolling through Pingala's network calls and I was not disappointed. Like I was disappointed because it sucks, but the amount of suspicious data I came across made that disappointment go away. When I convince my Dad to lend me his credit card, you can bet your ass that I am going to setup an AWS-lambda application that serves all the illegitimate data to me on demand. There is a list of 10 things I wish to see before I die, and if you remove all the unethical/immoral things in the list then it reduces to just one thing - a patched up Pingala. And Momina Mustehsan. Wildcard. 

## On Abandonment
As a kid, I remember squealing like a puppy when my mom left me alone for any duration longer than 15 minutes. I often succumb to an all-consuming rage and drink 4 Stings in rebellion when my friends cancel on me (this happens a lot more often than I'd like, unfortunately). This section, however, is not about my abandonment issues. It is about me abandoning a long-term project of mine, which I could have coded in 2 nights. But in characteristic Rahul fashion, I kept on procrastinating. And then came a day when I realised I did not need it anymore. 

## Rant
Now for purely dramatic purposes, let me fail miserably at weaving a story before I present my results. Any resemblance is unintentional. It is harsh winter the kind Delhi is known for, and you are bored. Instead for studying, you are mindlessly scrolling Instagram when you recieve a text you were not expecting. You spend a month chatting, and then some. And then they stop. Cold turkey. 

## Hinge
I have documented my (mis)adventures with Bumble previously, and its pretty sad vulnerability. It is possible to download photos before they are shown to you on the website. Great for catfishing. And things I will not delve into. This time I decided to make an account on Hinge chiefly because a very reliable source (my boy after 60 mililiters of Kalyanpur's finest imitation of Vodka) told me that it had better _quality_. To my dismay, though, Hinge does not have a web-app and I have not been able to patch any Android app for MITM attacks. I know I am a failure. However, my boy was correct.
